#pragma once
#include <iostream>
#include <algorithm>
#include <map>
#include <fstream>
#include <vector>
#include <cstdlib>
#include <iomanip>

class Product {
private:
	char number_warehouse[10];
	char code[10];
	char name[10];
	char date_day[10];
	char date_month[10];
	char date_year[10];
	char shelf_life[10];
	char quantity[10];
	char price[10];
public:
	Product() = default;//!!! Конструктор по умолчанию и так создается автоматически. +
	//!!! Деструктор и так создается автоматически. +

	//!!! Среди полей имеются указатели/массивы. Где контруктор копирования и оператор присваивания? +
	
	Product(const Product& elem);
	Product& operator =(const Product& elem);

	void NewProduct();

	int date_in_days() const;
	int Output_number_warehouse() const;
	int Output_code() const;
	std::string Output_name() const;
	std::vector<int> Output_date() const;
	int Output_shelf_life() const;
	int Output_quantity() const;
	int Output_price() const;
};

class List_Product {
private:
	std::map<size_t, Product> map_Product;
	size_t size = 0;
public:
	List_Product() = default;
	Product& operator[](size_t num);

	std::map<size_t, Product>& Output_map_Product();

	void Input(std::ifstream& file);
	void Output(std::ofstream& file);

	List_Product Search_by_warehouse_number();
	List_Product Search_by_product_code();
	List_Product Search_by_date_of_receipt();
	List_Product Search_by_shelf_life();

};

//!!! Вообще не понял, как так код пофайлам рабивать можно? +
//!!! Что тут делают эти объявления? Создавайте тогда Functions.h +

